#include "access.h"

bool Access::allowed(Character* pg){
	// leggi dati del personaggio
	TempSet<Feat>* c_feat=pg->getFeats();
	TempSet<Skill>* c_skill=pg->getSkills();
	set<Ownership>* c_owns=pg->getOwns();
	string c_name=pg->getName();
	string c_race=pg->getRace();
	
	// accesso
	bool ax=true;
	
	// controlla i permessi
	// features obbligatorie
	bool tmp=true;
	for(set<Feat>::iterator it=yes_feat.begin(); it!=yes_feat.end(); ++it)
		tmp=tmp && (c_feat->find(*it)!=c_feat->end());
	ax=ax && tmp;
	if (!ax) return false;
	
	// features vietate
	tmp=true;
	for(set<Feat>::iterator it=no_feat.begin(); it!=no_feat.end(); ++it)
		tmp=tmp && (c_feat->find(*it)==c_feat->end());
	ax=ax && tmp;
	if (!ax) return false;

	// razze consentite
	ax=ax && yes_race.find(c_race)!=yes_race.end();
	if (!ax) return false;

	// razze vietate
	ax=ax && no_race.find(c_race)==no_race.end();
	if (!ax) return false;
	
	// appartenenze consentite
	tmp=true;
	for(set<Ownership>::iterator it=yes_own.begin(); it!=yes_own.end(); ++it)
		tmp=tmp && (c_owns->find(*it)!=c_owns->end());
	ax=ax && tmp;
	if (!ax) return false;

	// appartenenze vietate
	tmp=true;
	for(set<Ownership>::iterator it=no_own.begin(); it!=no_own.end(); ++it)
		tmp=tmp && (c_owns->find(*it)==c_owns->end());
	ax=ax && tmp;
	if (!ax) return false;

	// skill con quantit minima
	tmp=true;
	for(set<Skill>::iterator it=yes_skill.begin(); it!=yes_skill.end(); ++it){
		// cerca la skill fra quelle del pg
		TempSet<Skill>::iterator sit=c_skill->find(*it);
		// se (non c' oppure c' ma ha quantit minore della minima)...
		if (sit==c_skill->end() || (*sit).q()<(*it).q())
			tmp=false;
	}
	ax=ax && tmp;
	if (!ax) return false;
	
	// skill con quantit massima
	tmp=true;
	for(set<Skill>::iterator it=yes_skill.begin(); it!=yes_skill.end(); ++it){
		// cerca la skill fra quelle del pg
		TempSet<Skill>::iterator sit=c_skill->find(*it);
		// se (c' oppure c' con quantit maggiore della massima)...
		if (sit!=c_skill->end() && (*sit).q()>(*it).q())
			tmp=false;
	}
	ax=ax && tmp;

	return ax;
}
